screen profiles():

    tag menu

    use game_menu(_("Profiles")):

        fixed:
            xfill True
            yfill True
            order_reverse True
            vpgrid: # the sum of these numbers MUST BE EQUAL to the number of buttons defined below, otherwise renpy will give an error
                cols 4
                yoffset -32
                draggable True
                mousewheel True
                scrollbars "vertical"
                style_prefix "profile"
                xspacing 24
                yspacing 48
                if persistent.shaneprofile: # need a flag so the game knows when to show a locked profile icon instead
                    button:
                        image "profiles/icons/shane.png" # the icon to use for this button, i got lazy and used jpegs but you don't have to - you can also use smaller icons than i did, again, i just got lazy
                        hover_foreground "name_shane" # a way to make the character's name show underneath the profile icon - not strictly necessary, depending on how you want to do things - see line 108
                        action Show("charprofile", char="shane")
                        # OK HERE WE GO
                        # char - the game uses this to search for the background image, see line 114
                        # cur_profile - there's a lot in this one line so here we go
                        # renpy.file(filename).read() tells it to load the content of the file - this is an ANSI-ENCODED TEXT FILE, though other encodings MIGHT work, not entirely sure
                        # .replace("\r","") - fixes linebreaks; otherwise we get a garbage character at the end of each line - you may not need this, your font seems to display fine without it
                        # a note on the file itself: I put a font argument at the beginning so it would actually use your font, but if you've already got that set as the default font in your game, you don't need to worry about this
                        # the file itself is formatted like renpy text - {size} for text size and such
                else:   # if we HAVEN'T unlocked this character's profile yet, show this instead
                    # if you want, you can turn this into a more elaborate check to show different profile info depending on where the player is - if variable == 1:; elif variable == 2:; else, etc.
                    button:
                        image "prof_blank"
                        hover_foreground "name_unk" # show question marks below the name - if you want the button to just not respond to mouse hover, don't include the following line
                        action Show("profiles") # renpy is dumb and buttons need an action to respond when the player mouses over them, but the dedicated "NullAction" command just exits back to the main menu
                if persistent.tripprofile:
                    button:
                        image "profiles/icons/tripp.png"
                        hover_foreground "name_tripp"
                        action Show("charprofile", char="tripp")
                else:
                    button:
                        image "prof_blank"
                        hover_foreground "name_unk"
                        action Show("profiles")
                if persistent.lucaprofile:
                    button:
                        image "profiles/icons/luca.png"
                        hover_foreground "name_luca"
                        action Show("charprofile", char="luca")
                else:
                    button:
                        image "prof_blank"
                        hover_foreground "name_unk"
                        action Show("profiles")
                if persistent.blaiseprofile:
                    button:
                        image "profiles/icons/blaise.png"
                        hover_foreground "name_blaise"
                        action Show("charprofile", char="blaise")
                else:
                    button:
                        image "prof_blank"
                        hover_foreground "name_unk"
                        action Show("profiles")
                if persistent.hendrixprofile:
                    button:
                        image "profiles/icons/hendrix.png"
                        hover_foreground "name_hendrix"
                        action Show("charprofile", char="hendrix")
                else:
                    button:
                        image "prof_blank"
                        hover_foreground "name_unk"
                        action Show("profiles")
                if persistent.alexprofile:
                    button:
                        image "profiles/icons/alex.png"
                        hover_foreground "name_alex"
                        action Show("charprofile", char="alex")
                else:
                    button:
                        image "prof_blank"
                        hover_foreground "name_unk"
                        action Show("profiles")
                if persistent.soraprofile:
                    button:
                        image "profiles/icons/sora.png"
                        hover_foreground "name_sora"
                        action Show("charprofile", char="sora")
                else:
                    button:
                        image "prof_blank"
                        hover_foreground "name_unk"
                        action Show("profiles")
                if persistent.jadenprofile:
                    button:
                        image "profiles/icons/jaden.png"
                        hover_foreground "name_jaden"
                        action Show("charprofile", char="jaden")
                else:
                    button:
                        image "prof_blank"
                        hover_foreground "name_unk"
                        action Show("profiles")
                if persistent.loganprofile:
                    button:
                        image "profiles/icons/logan.png"
                        hover_foreground "name_logan"
                        action Show("charprofile", char="logan")
                else:
                    button:
                        image "prof_blank"
                        hover_foreground "name_unk"
                        action Show("profiles")
                if persistent.gunnarprofile:
                    button:
                        image "profiles/icons/gunnar.png"
                        hover_foreground "name_gunnar"
                        action Show("charprofile", char="gunnar")
                else:
                    button:
                        image "prof_blank"
                        hover_foreground "name_unk"
                        action Show("profiles")
                if persistent.allisonprofile:
                    button:
                        image "profiles/icons/allison.png"
                        hover_foreground "name_allison"
                        action Show("charprofile", char="allison")
                else:
                    button:
                        image "prof_blank"
                        hover_foreground "name_unk"
                        action Show("profiles")
                if persistent.blankprofile:
                    button:
                        image "prof_blank"
                        hover_foreground "name_unk"
                        action Show("profiles")
                else:
                    button:
                        image "prof_blank"
                        hover_foreground "name_unk"
                        action Show("profiles")

style profile_button:
    activate_sound "sound_effects/button.mp3"
    # if you don't want the character's name underneath the button, then you can put a hover_foreground argument in here instead

screen charprofile(char): # this screen is used for every character profile - saves on code space

    tag menu # we need this for things to work

    add "profiles/[char]_bio.png" # uses the char argument to find the background

    frame:
        style "game_menu_content_frame" # this might have different results for you, let me know - for me, this line clears the screen so we just see the background as intended
        key "mouseup_3" action Show("profiles") # if the player presses the right mouse button, return to the previous menu - mouseup signifies the button being released
        fixed:
            frame:
                yalign 0.95
                xalign 0.985
                textbutton "Return": # back button
                    action Show("profiles")
                    activate_sound "sound_effects/button.mp3"
            window:
                background None
                top_padding 47
                left_padding 15
                xmaximum 720 # you might have to play with this

define persistent.shaneprofile = True # "unlock profile" flags
define persistent.tripprofile = True # none of these other profiles are set up lol, just the first one to demonstrate
define persistent.lucaprofile = True
define persistent.blaiseprofile = True
define persistent.hendrixprofile = True
define persistent.alexprofile = True
define persistent.soraprofile = True
define persistent.jadenprofile = True
define persistent.allisonprofile = True
define persistent.gunnarprofile = True
define persistent.loganprofile = True

image blacksquare = LiveComposite((200, 200), (0, 0), Solid("#000"))
image prof_blank = LiveComposite((200, 230), (0, 0), "blacksquare") # i just used a generic black square here but you can put a proper "lock" icon or something instead
image name_shane = LiveComposite((200, 200), (4, 150), "gui/profile_text_backdrop.png", (70, 153), Text("Shane", color="#0ed9c1")) # yalign 1.15 positions the text underneath the profile icon
image name_tripp = LiveComposite((200, 200), (4, 150), "gui/profile_text_backdrop.png", (70, 153), Text("Tripp", color="#f6a4de"))
image name_luca = LiveComposite((200, 200), (4, 150), "gui/profile_text_backdrop.png", (70, 153), Text("Luca", color="#bf7ddd"))
image name_blaise = LiveComposite((200, 200), (4, 150), "gui/profile_text_backdrop.png", (70, 153), Text("Blaise", color="#43e13d"))
image name_hendrix = LiveComposite((200, 200), (4, 150), "gui/profile_text_backdrop.png", (60, 153), Text("Hendrix", color="#ff000d"))
image name_alex = LiveComposite((200, 200), (4, 150), "gui/profile_text_backdrop.png", (70, 153), Text("Alex", color="#325fff"))
image name_sora = LiveComposite((200, 200), (4, 150), "gui/profile_text_backdrop.png", (70, 153), Text("Sora", color="#909090"))
image name_jaden = LiveComposite((200, 200), (4, 150), "gui/profile_text_backdrop.png", (70, 153), Text("Jaden", color="#f4ff3d"))
image name_logan = LiveComposite((200, 200), (4, 150), "gui/profile_text_backdrop.png", (70, 153), Text("Logan", color="#f26522"))
image name_gunnar = LiveComposite((200, 200), (4, 150), "gui/profile_text_backdrop.png", (25, 153), Text("Prof. Gunnar", color="#93631f"))
image name_allison = LiveComposite((200, 200), (4, 150), "gui/profile_text_backdrop.png", (60, 153), Text("Allison", color="#e330dc"))
image name_unk = LiveComposite((200, 200), (4, 150), "gui/profile_text_backdrop.png", (70, 153), Text("????", color="#ffffff"))

# lastly: to add the profiles button to the main menu, in screens.rpy, add a line like [textbutton _("Profiles" action ShowMenu("profiles")] under the "screen navigation()" label
